#include <stdio.h>
void swap_first_two(int* s){
    int tmp;
    tmp = s[0];
    s[0] = s[1];
    s[1] = tmp;
    return;
}

int main(){

    int a = 10;  // create an integer scalar
    int b = 5;   // another integer scalar
    int *p;      // create a pointer to integer (but it is not assigned)

    printf("The value of p before assignment is %p\n", (void *)p);
    p = &a;     // assign the address of a to p
    printf("The value of p is %p, which is the address of a\n", (void *)p);
    printf("The value of a is %d, accessed directly.\n", a);
    printf("The value of a is %d, accessed by dereferencing p (using *p)\n", *p);

    int *x; // create a pointer to integer
    x = &a;
    int *y;
    y = &b;

    int *tmp;
    
    printf("x points to a value %d, and y points to a value %d\n", *x, *y);

    tmp = x;
    x = y;
    y = tmp; 

    printf("x points to a value %d, and y points to a value %d\n", *x, *y);

    // array example
    int m[] = {1,5,2};
    // An array is just a pointer 
    printf("m points to a value %d\n", *m);
    printf("m[0] is the value %d\n", m[0]);

    // how to print out the second element in the array?
    printf("m points to a value %d\n", *(m+1));
    printf("m[1] is the value %d\n", m[1]);

    // show the progression of the pointer values
    // integer increments by sizeof(int) (often 4)
    printf("the value of m is  %p\n", (void *)m);
    printf("the value of m+1 is  %p\n", (void *)(m+1));

    void *v;
    v = m;
    // void pointer increments by 1
    printf("the value of v is  %p\n", v);
    printf("the value of v+1 is  %p\n", (v+1));

    // example use:
    printf("before swap:\n");
    printf("m[0] is the value %d\n", m[0]);
    printf("m[1] is the value %d\n", m[1]);
    swap_first_two(m);
    printf("after swap:\n");
    printf("m[0] is the value %d\n", m[0]);
    printf("m[1] is the value %d\n", m[1]);
     
    return 0;

    // fundamental takeaway:
    // 1. a pointer (p) contains a location in memory
    // 2. manipulating the pointer value changes where in memory we are pointing to 
    // 3. de-referencing the pointer (*p) allows us to access and/or 
    //      change the value stored at the memory location
    // 4. the address-of operator (&) returns the address of a variable, and this address
    //      can be assigned to a apointer


}
