#include <stdio.h>


void swap_first_two(int m[]){
    int t = m[0];
    m[0] = m[1];
    m[1] = t; 
    return; 
}

void swap_first_two_ptr(int *m){
    int t = *m;
    *m = *(m+1);
    *(m+1) = t; 
    return; 
}



int main(){

    printf("\n1. An array is a pointer \n");
    printf("referencing the first element.\n");
    int m[4] = {5,7,2,0};
    printf("m[0] is the value %d\n", m[0]);
    printf("*m is the value %d\n", *m);

    printf("\n2. We can access elements of the array by offsetting from the pointer :\n");
    printf("m[1] is the value %d\n", m[1]);
    printf("*(m+1) is the value %d\n", *(m+1));

    printf("\n3. We can also have pointers to scalars, which can also be offset (with less defined outcomes):\n");
    int *a;
    *a = 9;
    printf("*a = %d\n", *a);  
    printf("*a = %d\n", *(a-3));  // this is undefined, and might even crash the program 

    printf("\n4. Pointer values not meaningful as ints:\n");
    printf("m = %p (as memory location)\n", (void *)m);  
    printf("m = %d (as integer)\n", m);  
    printf("a = %p (as memory location)\n", (void *)a);  
    printf("a = %d (as integer)\n", a);  

    printf("\n5. Pointer arithmetic works in multiples of the base type (int, void, byte, short, long, etc) - int on this system is %d:\n", sizeof(int));
    printf("m = %p\n", (void *) m);
    printf("m+1 = %p\n", (void *) (m+1));
    int x = a - m;
    printf("distance between start of m and a is %d\n", x);

    
    printf("6. Pointers can be passed to functions\n");
    printf("before swap_first_two\n");
    printf("m[0] is the value %d\n", m[0]);
    printf("m[1] is the value %d\n", m[1]);

    swap_first_two(m);
    printf("after swap_first_two\n");
    printf("m[0] is the value %d\n", m[0]);
    printf("m[1] is the value %d\n", m[1]);

    swap_first_two_ptr(m);
    printf("after swap_first_two_ptr\n");
    printf("m[0] is the value %d\n", m[0]);
    printf("m[1] is the value %d\n", m[1]);
    printf("after swap_first_two_ptr\n");


    return 0;
}
