
class Rectangle:
    def __init__(self, width=1.0, height=1.0):
        self._width = width
        self._height = height


    def set_width(self, w):
        if w > 0:
            self._width = w
        else:
            raise ValueError("Width must be greater than 0")




class Vehicle:
  
  def __init__(self, make):
    self.__make = make

  # accessor (getter)
  def get_make(self):
    return self.__make

  # mutator (setter)
  def set_make(self, make):
    if self.__make == "Chevrolet" and make == "Pontiac":
      self.__make = make
  

myvehicle = Vehicle("VolksWagen")
# myvehicle = Vehicle() # this generates an error, because we expect a parameter
# myvehicle.__make = "Toyota" # this generates an error, because we cannot access a private member


# make 10 ford vehicles 
myvehicles = []
for i in range(10):
  myvehicles.append(Vehicle("Ford"))

for vehicle in myvehicles:
  print("before: ", vehicle.get_make())
  vehicle.set_make("Land Rover") # this would do nothing
  print("after: ", vehicle.get_make())
 
mychevrolets = list(Vehicle("Chevrolet") for i in range(10))  # uses a list comprehension

# TLDR - this is a list of ten vehicles, each is a Chevrolet
for vehicle in mychevrolets:
  print("before: ", vehicles.get_make())
  vehicles.set_make("Pontiac")
  print("after: ", vehicles.get_make())

# a Truck class below, inherits everything from Vehicle, 
# plus it can have exactly one cargo load at a time

class Truck(Vehicle):
  def __init__(self, make):
    self.__make = make
    self.__cargo = None

  def load_cargo(self, cargo):
    if self.__cargo is None:
      self.__cargo = cargo
    
  def check_cargo(self):
    return self.__cargo

  def remove_cargo(self):
    cargo = self.__cargo
    self.__cargo = None
    return cargo


