
# For loops

# pre-test loop with a simple true/false condition

name = ""
while name == "":
  name = input("Name: ")

# post-test loop
while True:
  name = input("Name: ")
  if name != "":
    break  

# iterating over several things (collection, range, generator)
for i in range(10):
  print(i)  # prints: 0-9

# classic for loop construct (done with while in python)
i=0
while i < 10:
  print(i)
  i = i + 1

## "for" constructs are best for going over a collection/range
## "while" constructs are best for waiting for some condition to happen

# concrete example
for i in range(1000000):
  print(i)

# the range function returns an iterable ojbject 
it = range(1000000)
# the iterable object contains an iterator
iterator = it.__iter__()
# the iteractor has a "next" functionality
iterator.__next__()
# or
next(iterator)
# eventually the next will fail, with a StopIteration exception
# this signals the end.

# this is immensely valuable if the list is not possible to have in memory or is uknown.

s = set(x for x in range(1000))


## for loop functionality can be approximated using while

mylist = [3,2,6,1,9]
p = 0 # p is going to be used as an index to express where we are looking in the list
while p < len(mylist): # if 0 < 5
    value = mylist[p]
    print(value)
    p = p + 1

mylist = [3,2,6,1,9] # mylist MUST exist beforehand
for value in mylist: # value is each successive element in mylist
    print(value)



